"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getEntries = void 0;
const escapeRegExp_1 = require("./escapeRegExp");
function getEntries(text, substrings, regExpFlags) {
    const arrayOfMatchesArrays = substrings.map((substring) => {
        return [...text.matchAll(new RegExp((0, escapeRegExp_1.escapeRegExp)(substring), regExpFlags))];
    });
    return arrayOfMatchesArrays.reduce((acc, matchesArray, index) => {
        const entries = matchesArray.reduce((acc, item) => {
            acc.push({
                startIndex: item.index || 0,
                endIndex: (item.index || 0) + substrings[index].length,
            });
            return acc;
        }, []);
        return [...acc, ...entries];
    }, []);
}
exports.getEntries = getEntries;
